/**
 * Binary Parser.
 * Jonas Raoni Soares Silva
 * http://jsfromhell.com/classes/binary-parser [v1.0]
 */function BinaryParser(a,b){if(!(this instanceof BinaryParser))return new BinaryParser(a,b);this.bigEndian=a,this.allowExceptions=b}function BinaryParserBuffer(a,b){this.bigEndian=a||0,this.buffer=[],this.setBuffer(b)}function Code(a,b){if(!(this instanceof Code))return new Code(a,b);this._bsontype="Code",this.code=a,this.scope=b==null?{}:b}function DBRef(a,b,c){if(!(this instanceof DBRef))return new DBRef(a,b,c);this._bsontype="DBRef",this.namespace=a,this.oid=b,this.db=c}function Double(a){if(!(this instanceof Double))return new Double(a);this._bsontype="Double",this.value=a}function Long(a,b){if(!(this instanceof Long))return new Long(a,b);this._bsontype="Long",this.low_=a|0,this.high_=b|0}function MaxKey(){if(!(this instanceof MaxKey))return new MaxKey;this._bsontype="MaxKey"}function MinKey(){if(!(this instanceof MinKey))return new MinKey;this._bsontype="MinKey"}function ObjectID(a,b){if(!(this instanceof ObjectID))return new ObjectID(a,b);this._bsontype="ObjectID";if(a!=null&&"number"!=typeof a&&a.length!=12&&a.length!=24)throw new Error("Argument passed in must be a single String of 12 bytes or a string of 24 hex characters");if(a==null||typeof a=="number")this.id=this.generate(a);else if(a!=null&&a.length===12)this.id=a;else if(checkForHexRegExp.test(a))return ObjectID.createFromHexString(a);Object.defineProperty(this,"generationTime",{enumerable:!0,get:function(){return Math.floor(BinaryParser.decodeInt(this.id.substring(0,4),32,!0,!0))},set:function(a){var a=BinaryParser.encodeInt(a,32,!0,!0);this.id=a+this.id.substr(4),delete this.__id,this.toHexString()}}),this.__id=b||this.toHexString()}function Symbol(a){if(!(this instanceof Symbol))return new Symbol(a);this._bsontype="Symbol",this.value=a}function Timestamp(a,b){if(!(this instanceof Timestamp))return new Timestamp(a,b);this._bsontype="Timestamp",this.low_=a|0,this.high_=b|0}function BSON(){}function calculateElement(a,b,c){var d=typeof Buffer!="undefined";switch(typeof b){case"string":return 1+(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1+4+(d?Buffer.byteLength(b,"utf8"):numberOfBytes(b))+1;case"number":return Math.floor(b)===b&&b>=BSON.JS_INT_MIN&&b<=BSON.JS_INT_MAX?b>=BSON.BSON_INT32_MIN&&b<=BSON.BSON_INT32_MAX?(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+5:(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+9:(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+9;case"undefined":return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1;case"boolean":return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+2;case"object":if(b==null||b instanceof MinKey||b instanceof MaxKey||b["_bsontype"]=="MinKey"||b["_bsontype"]=="MaxKey")return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1;if(b instanceof ObjectID||b["_bsontype"]=="ObjectID")return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+13;if(b instanceof Date)return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+9;if(typeof Buffer!="undefined"&&Buffer.isBuffer(b))return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+6+b.length;if(b instanceof Long||b instanceof Double||b instanceof Timestamp||b["_bsontype"]=="Long"||b["_bsontype"]=="Double"||b["_bsontype"]=="Timestamp")return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+9;if(b instanceof Code||b["_bsontype"]=="Code")return b.scope!=null&&Object.keys(b.scope).length>0?(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1+4+4+(d?Buffer.byteLength(b.code.toString(),"utf8"):numberOfBytes(b.code.toString()))+1+BSON.calculateObjectSize(b.scope,c):(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1+4+(d?Buffer.byteLength(b.code.toString(),"utf8"):numberOfBytes(b.code.toString()))+1;if(b instanceof Binary||b["_bsontype"]=="Binary")return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+(b.position+1+4+1);if(b instanceof Symbol||b["_bsontype"]=="Symbol")return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+((d?Buffer.byteLength(b.value,"utf8"):numberOfBytes(b.value))+4+1+1);if(b instanceof DBRef||b["_bsontype"]=="DBRef"){var e={$ref:b.namespace,$id:b.oid};return null!=b.db&&(e.$db=b.db),(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1+BSON.calculateObjectSize(e,c)}return b instanceof RegExp||Object.prototype.toString.call(b)==="[object RegExp]"?(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1+(d?Buffer.byteLength(b.source,"utf8"):numberOfBytes(b.source))+1+(b.global?1:0)+(b.ignoreCase?1:0)+(b.multiline?1:0)+1:(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+BSON.calculateObjectSize(b,c)+1;case"function":if(b instanceof RegExp||Object.prototype.toString.call(b)==="[object RegExp]"||String.call(b)=="[object RegExp]")return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1+(d?Buffer.byteLength(b.source,"utf8"):numberOfBytes(b.source))+1+(b.global?1:0)+(b.ignoreCase?1:0)+(b.multiline?1:0)+1;if(c&&b.scope!=null&&Object.keys(b.scope).length>0)return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1+4+4+(d?Buffer.byteLength(b.toString(),"utf8"):numberOfBytes(b.toString()))+1+BSON.calculateObjectSize(b.scope,c);if(c)return(a!=null?(d?Buffer.byteLength(a,"utf8"):numberOfBytes(a))+1:0)+1+4+(d?Buffer.byteLength(b.toString(),"utf8"):numberOfBytes(b.toString()))+1}return 0}function Binary(a,b){if(!(this instanceof Binary))return new Binary(a,b);this._bsontype="Binary",a instanceof Number?(this.sub_type=a,this.position=0):(this.sub_type=b==null?BSON_BINARY_SUBTYPE_DEFAULT:b,this.position=0);if(a==null||a instanceof Number)typeof Buffer!="undefined"?this.buffer=new Buffer(Binary.BUFFER_SIZE):typeof Uint8Array!="undefined"?this.buffer=new Uint8Array(new ArrayBuffer(Binary.BUFFER_SIZE)):this.buffer=new Array(Binary.BUFFER_SIZE),this.position=0;else{if(typeof a=="string")if(typeof Buffer!="undefined")this.buffer=new Buffer(a);else{if(typeof Uint8Array=="undefined"&&Object.prototype.toString.call(a)!="[object Array]")throw new Error("only String, Buffer, Uint8Array or Array accepted");this.buffer=writeStringToArray(a)}else this.buffer=a;this.position=a.length}}var chr=String.fromCharCode,maxBits=[];for(var i=0;i<64;i++)maxBits[i]=Math.pow(2,i);BinaryParser.warn=function(b){if(this.allowExceptions)throw new Error(b);return 1},BinaryParser.decodeFloat=function(b,c,d){var e=new this.Buffer(this.bigEndian,b);e.checkBuffer(c+d+1);var f=maxBits[d-1]-1,g=e.readBits(c+d,1),h=e.readBits(c,d),i=0,j=2,k=e.buffer.length+(-c>>3)-1;do for(var l=e.buffer[++k],m=c%8||8,n=1<<m;n>>=1;l&n&&(i+=1/j),j*=2);while(c-=m);return h==(f<<1)+1?i?NaN:g?-Infinity:+Infinity:(1+g*-2)*(h||i?h?Math.pow(2,h-f)*(1+i):Math.pow(2,-f+1)*i:0)},BinaryParser.decodeInt=function(b,c,d,e){var f=new this.Buffer(this.bigEndian||e,b),g=f.readBits(0,c),h=maxBits[c];return d&&g>=h/2?g-h:g},BinaryParser.encodeFloat=function(b,c,d){var e=maxBits[d-1]-1,f=-e+1,g=e,h=f-c,i=parseFloat(b),j=isNaN(i)||i==-Infinity||i==+Infinity?i:0,k=0,l=2*e+1+c+3,m=new Array(l),n=(i=j!==0?0:i)<0,o=Math.floor(i=Math.abs(i)),p=i-o,q,s,t,u,v;for(u=l;u;m[--u]=0);for(u=e+2;o&&u;m[--u]=o%2,o=Math.floor(o/2));for(u=e+1;p>0&&u;(m[++u]=((p*=2)>=1)-0)&&--p);for(u=-1;++u<l&&!m[u];);if(m[(q=c-1+(u=(k=e+1-u)>=f&&k<=g?u+1:e+1-(k=f-1)))+1]){if(!(s=m[q]))for(v=q+2;!s&&v<l;s=m[v++]);for(v=q+1;s&&--v>=0;(m[v]=!m[v]-0)&&(s=0));}for(u=u-2<0?-1:u-3;++u<l&&!m[u];);(k=e+1-u)>=f&&k<=g?++u:k<f&&(k!=e+1-l&&k<h&&this.warn("encodeFloat::float underflow"),u=e+1-(k=f-1));if(o||j!==0)this.warn(o?"encodeFloat::float overflow":"encodeFloat::"+j),k=g+1,u=e+2,j==-Infinity?n=1:isNaN(j)&&(m[u]=1);for(i=Math.abs(k+e),v=d+1,t="";--v;t=i%2+t,i=i>>=1);for(i=0,v=0,u=(t=(n?"1":"0")+t+m.slice(u,u+c).join("")).length,r=[];u;v=(v+1)%8)i+=(1<<v)*t.charAt(--u),v==7&&(r[r.length]=String.fromCharCode(i),i=0);return r[r.length]=i?String.fromCharCode(i):"",(this.bigEndian?r.reverse():r).join("")},BinaryParser.encodeInt=function(b,c,d,e){var f=maxBits[c];if(b>=f||b<-(f/2))this.warn("encodeInt::overflow"),b=0;b<0&&(b+=f);for(var g=[];b;g[g.length]=String.fromCharCode(b%256),b=Math.floor(b/256));for(c=-(-c>>3)-g.length;c--;g[g.length]="\0");return(this.bigEndian||e?g.reverse():g).join("")},BinaryParser.toSmall=function(a){return this.decodeInt(a,8,!0)},BinaryParser.fromSmall=function(a){return this.encodeInt(a,8,!0)},BinaryParser.toByte=function(a){return this.decodeInt(a,8,!1)},BinaryParser.fromByte=function(a){return this.encodeInt(a,8,!1)},BinaryParser.toShort=function(a){return this.decodeInt(a,16,!0)},BinaryParser.fromShort=function(a){return this.encodeInt(a,16,!0)},BinaryParser.toWord=function(a){return this.decodeInt(a,16,!1)},BinaryParser.fromWord=function(a){return this.encodeInt(a,16,!1)},BinaryParser.toInt=function(a){return this.decodeInt(a,32,!0)},BinaryParser.fromInt=function(a){return this.encodeInt(a,32,!0)},BinaryParser.toLong=function(a){return this.decodeInt(a,64,!0)},BinaryParser.fromLong=function(a){return this.encodeInt(a,64,!0)},BinaryParser.toDWord=function(a){return this.decodeInt(a,32,!1)},BinaryParser.fromDWord=function(a){return this.encodeInt(a,32,!1)},BinaryParser.toQWord=function(a){return this.decodeInt(a,64,!0)},BinaryParser.fromQWord=function(a){return this.encodeInt(a,64,!0)},BinaryParser.toFloat=function(a){return this.decodeFloat(a,23,8)},BinaryParser.fromFloat=function(a){return this.encodeFloat(a,23,8)},BinaryParser.toDouble=function(a){return this.decodeFloat(a,52,11)},BinaryParser.fromDouble=function(a){return this.encodeFloat(a,52,11)},BinaryParser.encode_int32=function(b,c){var d,e,f,g,h;return h=b<0?b+4294967296:b,d=Math.floor(h/16777215),h&=16777215,e=Math.floor(h/65535),h&=65535,f=Math.floor(h/255),h&=255,g=Math.floor(h),c?[chr(d),chr(e),chr(f),chr(g)]:chr(d)+chr(e)+chr(f)+chr(g)},BinaryParser.encode_int64=function(b){var c,d,e,f,g,h,i,j,k;return k=b<0?b+0x10000000000000000:b,c=Math.floor(k/72057594037927940),k&=72057594037927940,d=Math.floor(k/0xffffffffffff),k&=0xffffffffffff,e=Math.floor(k/0xffffffffff),k&=0xffffffffff,f=Math.floor(k/4294967295),k&=4294967295,g=Math.floor(k/16777215),k&=16777215,h=Math.floor(k/65535),k&=65535,i=Math.floor(k/255),k&=255,j=Math.floor(k),chr(c)+chr(d)+chr(e)+chr(f)+chr(g)+chr(h)+chr(i)+chr(j)},BinaryParser.decode_utf8=function(b){var c=b.length,d="",e=0,f=0,g=0,h=0,i;while(e<c)f=b.charCodeAt(e),f<128?(d+=String.fromCharCode(f),e++):f>191&&f<224?(h=b.charCodeAt(e+1),d+=String.fromCharCode((f&31)<<6|h&63),e+=2):(h=b.charCodeAt(e+1),i=b.charCodeAt(e+2),d+=String.fromCharCode((f&15)<<12|(h&63)<<6|i&63),e+=3);return d},BinaryParser.encode_cstring=function(b){return unescape(encodeURIComponent(b))+BinaryParser.fromByte(0)},BinaryParser.encode_utf8=function(b){var c="",d;for(var e=0,f=b.length;e<f;e++)d=b.charCodeAt(e),d<128?c+=String.fromCharCode(d):d>127&&d<2048?(c+=String.fromCharCode(d>>6|192),c+=String.fromCharCode(d&63|128)):(c+=String.fromCharCode(d>>12|224),c+=String.fromCharCode(d>>6&63|128),c+=String.fromCharCode(d&63|128));return c},BinaryParser.hprint=function(b){var c;for(var d=0,e=b.length;d<e;d++)b.charCodeAt(d)<32?(c=b.charCodeAt(d)<=15?"0"+b.charCodeAt(d).toString(16):b.charCodeAt(d).toString(16),process.stdout.write(c+" ")):(c=b.charCodeAt(d)<=15?"0"+b.charCodeAt(d).toString(16):b.charCodeAt(d).toString(16),process.stdout.write(c+" "));process.stdout.write("\n\n")},BinaryParser.ilprint=function(b){var c;for(var d=0,e=b.length;d<e;d++)b.charCodeAt(d)<32?(c=b.charCodeAt(d)<=15?"0"+b.charCodeAt(d).toString(10):b.charCodeAt(d).toString(10),require("util").debug(c+" : ")):(c=b.charCodeAt(d)<=15?"0"+b.charCodeAt(d).toString(10):b.charCodeAt(d).toString(10),require("util").debug(c+" : "+b.charAt(d)))},BinaryParser.hlprint=function(b){var c;for(var d=0,e=b.length;d<e;d++)b.charCodeAt(d)<32?(c=b.charCodeAt(d)<=15?"0"+b.charCodeAt(d).toString(16):b.charCodeAt(d).toString(16),require("util").debug(c+" : ")):(c=b.charCodeAt(d)<=15?"0"+b.charCodeAt(d).toString(16):b.charCodeAt(d).toString(16),require("util").debug(c+" : "+b.charAt(d)))},BinaryParserBuffer.prototype.setBuffer=function(b){var c,d,e;if(b){d=c=b.length,e=this.buffer=new Array(c);for(;d;e[c-d]=b.charCodeAt(--d));this.bigEndian&&e.reverse()}},BinaryParserBuffer.prototype.hasNeededBits=function(b){return this.buffer.length>=-(-b>>3)},BinaryParserBuffer.prototype.checkBuffer=function(b){if(!this.hasNeededBits(b))throw new Error("checkBuffer::missing bytes")},BinaryParserBuffer.prototype.readBits=function(b,c){function d(a,b){for(;b--;a=((a%=2147483647+1)&1073741824)==1073741824?a*2:(a-1073741824)*2+2147483647+1);return a}if(b<0||c<=0)return 0;this.checkBuffer(b+c);var e,f=b%8,g=this.buffer.length-(b>>3)-1,h=this.buffer.length+(-(b+c)>>3),i=g-h,j=(this.buffer[g]>>f&(1<<(i?8-f:c))-1)+(i&&(e=(b+c)%8)?(this.buffer[h++]&(1<<e)-1)<<(i--<<3)-f:0);for(;i;j+=d(this.buffer[h++],(i--<<3)-f));return j},BinaryParser.Buffer=BinaryParserBuffer,typeof window=="undefined"&&(exports.BinaryParser=BinaryParser),Code.prototype.toJSON=function(){return{scope:this.scope,code:this.code}},typeof window=="undefined"&&(exports.Code=Code),DBRef.prototype.toJSON=function(){return{$ref:this.namespace,$id:this.oid,$db:this.db==null?"":this.db}},typeof window=="undefined"&&(exports.DBRef=DBRef),Double.prototype.valueOf=function(){return this.value},Double.prototype.toJSON=function(){return this.value},typeof window=="undefined"&&(exports.Double=Double);var readIEEE754=function(a,b,c,d,e){var f,g,h=c==="big",i=e*8-d-1,j=(1<<i)-1,k=j>>1,l=-7,m=h?0:e-1,n=h?1:-1,o=a[b+m];m+=n,f=o&(1<<-l)-1,o>>=-l,l+=i;for(;l>0;f=f*256+a[b+m],m+=n,l-=8);g=f&(1<<-l)-1,f>>=-l,l+=d;for(;l>0;g=g*256+a[b+m],m+=n,l-=8);if(f===0)f=1-k;else{if(f===j)return g?NaN:(o?-1:1)*Infinity;g+=Math.pow(2,d),f-=k}return(o?-1:1)*g*Math.pow(2,f-d)},writeIEEE754=function(a,b,c,d,e,f){var g,h,i,j=d==="big",k=f*8-e-1,l=(1<<k)-1,m=l>>1,n=e===23?Math.pow(2,-24)-Math.pow(2,-77):0,o=j?f-1:0,p=j?-1:1,q=b<0||b===0&&1/b<0?1:0;b=Math.abs(b),isNaN(b)||b===Infinity?(h=isNaN(b)?1:0,g=l):(g=Math.floor(Math.log(b)/Math.LN2),b*(i=Math.pow(2,-g))<1&&(g--,i*=2),g+m>=1?b+=n/i:b+=n*Math.pow(2,1-m),b*i>=2&&(g++,i/=2),g+m>=l?(h=0,g=l):g+m>=1?(h=(b*i-1)*Math.pow(2,e),g+=m):(h=b*Math.pow(2,m-1)*Math.pow(2,e),g=0));for(;e>=8;a[c+o]=h&255,o+=p,h/=256,e-=8);g=g<<e|h,k+=e;for(;k>0;a[c+o]=g&255,o+=p,g/=256,k-=8);a[c+o-p]|=q*128};typeof window=="undefined"&&(exports.readIEEE754=readIEEE754,exports.writeIEEE754=writeIEEE754),Long.prototype.toInt=function(){return this.low_},Long.prototype.toNumber=function(){return this.high_*Long.TWO_PWR_32_DBL_+this.getLowBitsUnsigned()},Long.prototype.toJSON=function(){return this.toString()},Long.prototype.toString=function(a){var b=a||10;if(b<2||36<b)throw Error("radix out of range: "+b);if(this.isZero())return"0";if(this.isNegative()){if(this.equals(Long.MIN_VALUE)){var c=Long.fromNumber(b),d=this.div(c),e=d.multiply(c).subtract(this);return d.toString(b)+e.toInt().toString(b)}return"-"+this.negate().toString(b)}var f=Long.fromNumber(Math.pow(b,6)),e=this,g="";for(;;){var h=e.div(f),i=e.subtract(h.multiply(f)).toInt(),j=i.toString(b);e=h;if(e.isZero())return j+g;while(j.length<6)j="0"+j;g=""+j+g}},Long.prototype.getHighBits=function(){return this.high_},Long.prototype.getLowBits=function(){return this.low_},Long.prototype.getLowBitsUnsigned=function(){return this.low_>=0?this.low_:Long.TWO_PWR_32_DBL_+this.low_},Long.prototype.getNumBitsAbs=function(){if(this.isNegative())return this.equals(Long.MIN_VALUE)?64:this.negate().getNumBitsAbs();var a=this.high_!=0?this.high_:this.low_;for(var b=31;b>0;b--)if((a&1<<b)!=0)break;return this.high_!=0?b+33:b+1},Long.prototype.isZero=function(){return this.high_==0&&this.low_==0},Long.prototype.isNegative=function(){return this.high_<0},Long.prototype.isOdd=function(){return(this.low_&1)==1},Long.prototype.equals=function(a){return this.high_==a.high_&&this.low_==a.low_},Long.prototype.notEquals=function(a){return this.high_!=a.high_||this.low_!=a.low_},Long.prototype.lessThan=function(a){return this.compare(a)<0},Long.prototype.lessThanOrEqual=function(a){return this.compare(a)<=0},Long.prototype.greaterThan=function(a){return this.compare(a)>0},Long.prototype.greaterThanOrEqual=function(a){return this.compare(a)>=0},Long.prototype.compare=function(a){if(this.equals(a))return 0;var b=this.isNegative(),c=a.isNegative();return b&&!c?-1:!b&&c?1:this.subtract(a).isNegative()?-1:1},Long.prototype.negate=function(){return this.equals(Long.MIN_VALUE)?Long.MIN_VALUE:this.not().add(Long.ONE)},Long.prototype.add=function(a){var b=this.high_>>>16,c=this.high_&65535,d=this.low_>>>16,e=this.low_&65535,f=a.high_>>>16,g=a.high_&65535,h=a.low_>>>16,i=a.low_&65535,j=0,k=0,l=0,m=0;return m+=e+i,l+=m>>>16,m&=65535,l+=d+h,k+=l>>>16,l&=65535,k+=c+g,j+=k>>>16,k&=65535,j+=b+f,j&=65535,Long.fromBits(l<<16|m,j<<16|k)},Long.prototype.subtract=function(a){return this.add(a.negate())},Long.prototype.multiply=function(a){if(this.isZero())return Long.ZERO;if(a.isZero())return Long.ZERO;if(this.equals(Long.MIN_VALUE))return a.isOdd()?Long.MIN_VALUE:Long.ZERO;if(a.equals(Long.MIN_VALUE))return this.isOdd()?Long.MIN_VALUE:Long.ZERO;if(this.isNegative())return a.isNegative()?this.negate().multiply(a.negate()):this.negate().multiply(a).negate();if(a.isNegative())return this.multiply(a.negate()).negate();if(this.lessThan(Long.TWO_PWR_24_)&&a.lessThan(Long.TWO_PWR_24_))return Long.fromNumber(this.toNumber()*a.toNumber());var b=this.high_>>>16,c=this.high_&65535,d=this.low_>>>16,e=this.low_&65535,f=a.high_>>>16,g=a.high_&65535,h=a.low_>>>16,i=a.low_&65535,j=0,k=0,l=0,m=0;return m+=e*i,l+=m>>>16,m&=65535,l+=d*i,k+=l>>>16,l&=65535,l+=e*h,k+=l>>>16,l&=65535,k+=c*i,j+=k>>>16,k&=65535,k+=d*h,j+=k>>>16,k&=65535,k+=e*g,j+=k>>>16,k&=65535,j+=b*i+c*h+d*g+e*f,j&=65535,Long.fromBits(l<<16|m,j<<16|k)},Long.prototype.div=function(a){if(a.isZero())throw Error("division by zero");if(this.isZero())return Long.ZERO;if(this.equals(Long.MIN_VALUE)){if(a.equals(Long.ONE)||a.equals(Long.NEG_ONE))return Long.MIN_VALUE;if(a.equals(Long.MIN_VALUE))return Long.ONE;var b=this.shiftRight(1),c=b.div(a).shiftLeft(1);if(c.equals(Long.ZERO))return a.isNegative()?Long.ONE:Long.NEG_ONE;var d=this.subtract(a.multiply(c)),e=c.add(d.div(a));return e}if(a.equals(Long.MIN_VALUE))return Long.ZERO;if(this.isNegative())return a.isNegative()?this.negate().div(a.negate()):this.negate().div(a).negate();if(a.isNegative())return this.div(a.negate()).negate();var f=Long.ZERO,d=this;while(d.greaterThanOrEqual(a)){var c=Math.max(1,Math.floor(d.toNumber()/a.toNumber())),g=Math.ceil(Math.log(c)/Math.LN2),h=g<=48?1:Math.pow(2,g-48),i=Long.fromNumber(c),j=i.multiply(a);while(j.isNegative()||j.greaterThan(d))c-=h,i=Long.fromNumber(c),j=i.multiply(a);i.isZero()&&(i=Long.ONE),f=f.add(i),d=d.subtract(j)}return f},Long.prototype.modulo=function(a){return this.subtract(this.div(a).multiply(a))},Long.prototype.not=function(){return Long.fromBits(~this.low_,~this.high_)},Long.prototype.and=function(a){return Long.fromBits(this.low_&a.low_,this.high_&a.high_)},Long.prototype.or=function(a){return Long.fromBits(this.low_|a.low_,this.high_|a.high_)},Long.prototype.xor=function(a){return Long.fromBits(this.low_^a.low_,this.high_^a.high_)},Long.prototype.shiftLeft=function(a){a&=63;if(a==0)return this;var b=this.low_;if(a<32){var c=this.high_;return Long.fromBits(b<<a,c<<a|b>>>32-a)}return Long.fromBits(0,b<<a-32)},Long.prototype.shiftRight=function(a){a&=63;if(a==0)return this;var b=this.high_;if(a<32){var c=this.low_;return Long.fromBits(c>>>a|b<<32-a,b>>a)}return Long.fromBits(b>>a-32,b>=0?0:-1)},Long.prototype.shiftRightUnsigned=function(a){a&=63;if(a==0)return this;var b=this.high_;if(a<32){var c=this.low_;return Long.fromBits(c>>>a|b<<32-a,b>>>a)}return a==32?Long.fromBits(b,0):Long.fromBits(b>>>a-32,0)},Long.fromInt=function(a){if(-128<=a&&a<128){var b=Long.INT_CACHE_[a];if(b)return b}var c=new Long(a|0,a<0?-1:0);return-128<=a&&a<128&&(Long.INT_CACHE_[a]=c),c},Long.fromNumber=function(a){return isNaN(a)||!isFinite(a)?Long.ZERO:a<=-Long.TWO_PWR_63_DBL_?Long.MIN_VALUE:a+1>=Long.TWO_PWR_63_DBL_?Long.MAX_VALUE:a<0?Long.fromNumber(-a).negate():new Long(a%Long.TWO_PWR_32_DBL_|0,a/Long.TWO_PWR_32_DBL_|0)},Long.fromBits=function(a,b){return new Long(a,b)},Long.fromString=function(a,b){if(a.length==0)throw Error("number format error: empty string");var c=b||10;if(c<2||36<c)throw Error("radix out of range: "+c);if(a.charAt(0)=="-")return Long.fromString(a.substring(1),c).negate();if(a.indexOf("-")>=0)throw Error('number format error: interior "-" character: '+a);var d=Long.fromNumber(Math.pow(c,8)),e=Long.ZERO;for(var f=0;f<a.length;f+=8){var g=Math.min(8,a.length-f),h=parseInt(a.substring(f,f+g),c);if(g<8){var i=Long.fromNumber(Math.pow(c,g));e=e.multiply(i).add(Long.fromNumber(h))}else e=e.multiply(d),e=e.add(Long.fromNumber(h))}return e},Long.INT_CACHE_={},Long.TWO_PWR_16_DBL_=65536,Long.TWO_PWR_24_DBL_=1<<24,Long.TWO_PWR_32_DBL_=Long.TWO_PWR_16_DBL_*Long.TWO_PWR_16_DBL_,Long.TWO_PWR_31_DBL_=Long.TWO_PWR_32_DBL_/2,Long.TWO_PWR_48_DBL_=Long.TWO_PWR_32_DBL_*Long.TWO_PWR_16_DBL_,Long.TWO_PWR_64_DBL_=Long.TWO_PWR_32_DBL_*Long.TWO_PWR_32_DBL_,Long.TWO_PWR_63_DBL_=Long.TWO_PWR_64_DBL_/2,Long.ZERO=Long.fromInt(0),Long.ONE=Long.fromInt(1),Long.NEG_ONE=Long.fromInt(-1),Long.MAX_VALUE=Long.fromBits(-1,2147483647),Long.MIN_VALUE=Long.fromBits(0,-2147483648),Long.TWO_PWR_24_=Long.fromInt(1<<24),typeof window=="undefined"&&(exports.Long=Long),typeof window=="undefined"&&(exports.MaxKey=MaxKey),typeof window=="undefined"&&(exports.MinKey=MinKey);if(typeof window=="undefined")var BinaryParser=require("./binary_parser").BinaryParser;var MACHINE_ID=parseInt(Math.random()*16777215,10),checkForHexRegExp=new RegExp("^[0-9a-fA-F]{24}$");ObjectID.prototype.get_inc=function(){return ObjectID.index=(ObjectID.index+1)%16777215},ObjectID.prototype.getInc=function(){return this.get_inc()},ObjectID.prototype.generate=function(a){if("number"==typeof a)var b=BinaryParser.encodeInt(a,32,!0,!0),c=BinaryParser.encodeInt(MACHINE_ID,24,!1),d=BinaryParser.fromShort(typeof process=="undefined"?Math.floor(Math.random()*1e5):process.pid),e=BinaryParser.encodeInt(this.get_inc(),24,!1,!0);else var f=parseInt(Date.now()/1e3,10),b=BinaryParser.encodeInt(f,32,!0,!0),c=BinaryParser.encodeInt(MACHINE_ID,24,!1),d=BinaryParser.fromShort(typeof process=="undefined"?Math.floor(Math.random()*1e5):process.pid),e=BinaryParser.encodeInt(this.get_inc(),24,!1,!0);return b+c+d+e},ObjectID.prototype.toHexString=function(){if(this.__id)return this.__id;var a="",b,c;for(var d=0,e=this.id.length;d<e;d++)c=BinaryParser.toByte(this.id[d]),b=c<=15?"0"+c.toString(16):c.toString(16),a+=b;return this.__id=a},ObjectID.prototype.toString=function(){return this.toHexString()},ObjectID.prototype.inspect=ObjectID.prototype.toString,ObjectID.prototype.toJSON=function(){return this.toHexString()},ObjectID.prototype.equals=function(b){var c=b instanceof ObjectID||b.toHexString?b.id:ObjectID.createFromHexString(b).id;return this.id===c},ObjectID.prototype.getTimestamp=function(){var a=new Date;return a.setTime(Math.floor(BinaryParser.decodeInt(this.id.substring(0,4),32,!0,!0))*1e3),a},ObjectID.index=0,ObjectID.createPk=function(){return new ObjectID},ObjectID.createFromTime=function(b){var c=BinaryParser.encodeInt(b,32,!0,!0)+BinaryParser.encodeInt(0,64,!0,!0);return new ObjectID(c)},ObjectID.createFromHexString=function(b){if(typeof b=="undefined"||b!=null&&b.length!=24)throw new Error("Argument passed in must be a single String of 12 bytes or a string of 24 hex characters");var c=b.length;if(c>24)throw new Error("Id cannot be longer than 12 bytes");var d="",e,f;for(var g=0;g<c;g+=2)e=b.substr(g,2),f=parseInt(e,16),d+=BinaryParser.fromByte(f);return new ObjectID(d,b)},typeof window=="undefined"&&(exports.ObjectID=ObjectID),Symbol.prototype.valueOf=function(){return this.value},Symbol.prototype.toString=function(){return this.value},Symbol.prototype.inspect=function(){return this.value},Symbol.prototype.toJSON=function(){return this.value},typeof window=="undefined"&&(exports.Symbol=Symbol),Timestamp.prototype.toInt=function(){return this.low_},Timestamp.prototype.toNumber=function(){return this.high_*Timestamp.TWO_PWR_32_DBL_+this.getLowBitsUnsigned()},Timestamp.prototype.toJSON=function(){return this.toString()},Timestamp.prototype.toString=function(a){var b=a||10;if(b<2||36<b)throw Error("radix out of range: "+b);if(this.isZero())return"0";if(this.isNegative()){if(this.equals(Timestamp.MIN_VALUE)){var c=Timestamp.fromNumber(b),d=this.div(c),e=d.multiply(c).subtract(this);return d.toString(b)+e.toInt().toString(b)}return"-"+this.negate().toString(b)}var f=Timestamp.fromNumber(Math.pow(b,6)),e=this,g="";for(;;){var h=e.div(f),i=e.subtract(h.multiply(f)).toInt(),j=i.toString(b);e=h;if(e.isZero())return j+g;while(j.length<6)j="0"+j;g=""+j+g}},Timestamp.prototype.getHighBits=function(){return this.high_},Timestamp.prototype.getLowBits=function(){return this.low_},Timestamp.prototype.getLowBitsUnsigned=function(){return this.low_>=0?this.low_:Timestamp.TWO_PWR_32_DBL_+this.low_},Timestamp.prototype.getNumBitsAbs=function(){if(this.isNegative())return this.equals(Timestamp.MIN_VALUE)?64:this.negate().getNumBitsAbs();var a=this.high_!=0?this.high_:this.low_;for(var b=31;b>0;b--)if((a&1<<b)!=0)break;return this.high_!=0?b+33:b+1},Timestamp.prototype.isZero=function(){return this.high_==0&&this.low_==0},Timestamp.prototype.isNegative=function(){return this.high_<0},Timestamp.prototype.isOdd=function(){return(this.low_&1)==1},Timestamp.prototype.equals=function(a){return this.high_==a.high_&&this.low_==a.low_},Timestamp.prototype.notEquals=function(a){return this.high_!=a.high_||this.low_!=a.low_},Timestamp.prototype.lessThan=function(a){return this.compare(a)<0},Timestamp.prototype.lessThanOrEqual=function(a){return this.compare(a)<=0},Timestamp.prototype.greaterThan=function(a){return this.compare(a)>0},Timestamp.prototype.greaterThanOrEqual=function(a){return this.compare(a)>=0},Timestamp.prototype.compare=function(a){if(this.equals(a))return 0;var b=this.isNegative(),c=a.isNegative();return b&&!c?-1:!b&&c?1:this.subtract(a).isNegative()?-1:1},Timestamp.prototype.negate=function(){return this.equals(Timestamp.MIN_VALUE)?Timestamp.MIN_VALUE:this.not().add(Timestamp.ONE)},Timestamp.prototype.add=function(a){var b=this.high_>>>16,c=this.high_&65535,d=this.low_>>>16,e=this.low_&65535,f=a.high_>>>16,g=a.high_&65535,h=a.low_>>>16,i=a.low_&65535,j=0,k=0,l=0,m=0;return m+=e+i,l+=m>>>16,m&=65535,l+=d+h,k+=l>>>16,l&=65535,k+=c+g,j+=k>>>16,k&=65535,j+=b+f,j&=65535,Timestamp.fromBits(l<<16|m,j<<16|k)},Timestamp.prototype.subtract=function(a){return this.add(a.negate())},Timestamp.prototype.multiply=function(a){if(this.isZero())return Timestamp.ZERO;if(a.isZero())return Timestamp.ZERO;if(this.equals(Timestamp.MIN_VALUE))return a.isOdd()?Timestamp.MIN_VALUE:Timestamp.ZERO;if(a.equals(Timestamp.MIN_VALUE))return this.isOdd()?Timestamp.MIN_VALUE:Timestamp.ZERO;if(this.isNegative())return a.isNegative()?this.negate().multiply(a.negate()):this.negate().multiply(a).negate();if(a.isNegative())return this.multiply(a.negate()).negate();if(this.lessThan(Timestamp.TWO_PWR_24_)&&a.lessThan(Timestamp.TWO_PWR_24_))return Timestamp.fromNumber(this.toNumber()*a.toNumber());var b=this.high_>>>16,c=this.high_&65535,d=this.low_>>>16,e=this.low_&65535,f=a.high_>>>16,g=a.high_&65535,h=a.low_>>>16,i=a.low_&65535,j=0,k=0,l=0,m=0;return m+=e*i,l+=m>>>16,m&=65535,l+=d*i,k+=l>>>16,l&=65535,l+=e*h,k+=l>>>16,l&=65535,k+=c*i,j+=k>>>16,k&=65535,k+=d*h,j+=k>>>16,k&=65535,k+=e*g,j+=k>>>16,k&=65535,j+=b*i+c*h+d*g+e*f,j&=65535,Timestamp.fromBits(l<<16|m,j<<16|k)},Timestamp.prototype.div=function(a){if(a.isZero())throw Error("division by zero");if(this.isZero())return Timestamp.ZERO;if(this.equals(Timestamp.MIN_VALUE)){if(a.equals(Timestamp.ONE)||a.equals(Timestamp.NEG_ONE))return Timestamp.MIN_VALUE;if(a.equals(Timestamp.MIN_VALUE))return Timestamp.ONE;var b=this.shiftRight(1),c=b.div(a).shiftLeft(1);if(c.equals(Timestamp.ZERO))return a.isNegative()?Timestamp.ONE:Timestamp.NEG_ONE;var d=this.subtract(a.multiply(c)),e=c.add(d.div(a));return e}if(a.equals(Timestamp.MIN_VALUE))return Timestamp.ZERO;if(this.isNegative())return a.isNegative()?this.negate().div(a.negate()):this.negate().div(a).negate();if(a.isNegative())return this.div(a.negate()).negate();var f=Timestamp.ZERO,d=this;while(d.greaterThanOrEqual(a)){var c=Math.max(1,Math.floor(d.toNumber()/a.toNumber())),g=Math.ceil(Math.log(c)/Math.LN2),h=g<=48?1:Math.pow(2,g-48),i=Timestamp.fromNumber(c),j=i.multiply(a);while(j.isNegative()||j.greaterThan(d))c-=h,i=Timestamp.fromNumber(c),j=i.multiply(a);i.isZero()&&(i=Timestamp.ONE),f=f.add(i),d=d.subtract(j)}return f},Timestamp.prototype.modulo=function(a){return this.subtract(this.div(a).multiply(a))},Timestamp.prototype.not=function(){return Timestamp.fromBits(~this.low_,~this.high_)},Timestamp.prototype.and=function(a){return Timestamp.fromBits(this.low_&a.low_,this.high_&a.high_)},Timestamp.prototype.or=function(a){return Timestamp.fromBits(this.low_|a.low_,this.high_|a.high_)},Timestamp.prototype.xor=function(a){return Timestamp.fromBits(this.low_^a.low_,this.high_^a.high_)},Timestamp.prototype.shiftLeft=function(a){a&=63;if(a==0)return this;var b=this.low_;if(a<32){var c=this.high_;return Timestamp.fromBits(b<<a,c<<a|b>>>32-a)}return Timestamp.fromBits(0,b<<a-32)},Timestamp.prototype.shiftRight=function(a){a&=63;if(a==0)return this;var b=this.high_;if(a<32){var c=this.low_;return Timestamp.fromBits(c>>>a|b<<32-a,b>>a)}return Timestamp.fromBits(b>>a-32,b>=0?0:-1)},Timestamp.prototype.shiftRightUnsigned=function(a){a&=63;if(a==0)return this;var b=this.high_;if(a<32){var c=this.low_;return Timestamp.fromBits(c>>>a|b<<32-a,b>>>a)}return a==32?Timestamp.fromBits(b,0):Timestamp.fromBits(b>>>a-32,0)},Timestamp.fromInt=function(a){if(-128<=a&&a<128){var b=Timestamp.INT_CACHE_[a];if(b)return b}var c=new Timestamp(a|0,a<0?-1:0);return-128<=a&&a<128&&(Timestamp.INT_CACHE_[a]=c),c},Timestamp.fromNumber=function(a){return isNaN(a)||!isFinite(a)?Timestamp.ZERO:a<=-Timestamp.TWO_PWR_63_DBL_?Timestamp.MIN_VALUE:a+1>=Timestamp.TWO_PWR_63_DBL_?Timestamp.MAX_VALUE:a<0?Timestamp.fromNumber(-a).negate():new Timestamp(a%Timestamp.TWO_PWR_32_DBL_|0,a/Timestamp.TWO_PWR_32_DBL_|0)},Timestamp.fromBits=function(a,b){return new Timestamp(a,b)},Timestamp.fromString=function(a,b){if(a.length==0)throw Error("number format error: empty string");var c=b||10;if(c<2||36<c)throw Error("radix out of range: "+c);if(a.charAt(0)=="-")return Timestamp.fromString(a.substring(1),c).negate();if(a.indexOf("-")>=0)throw Error('number format error: interior "-" character: '+a);var d=Timestamp.fromNumber(Math.pow(c,8)),e=Timestamp.ZERO;for(var f=0;f<a.length;f+=8){var g=Math.min(8,a.length-f),h=parseInt(a.substring(f,f+g),c);if(g<8){var i=Timestamp.fromNumber(Math.pow(c,g));e=e.multiply(i).add(Timestamp.fromNumber(h))}else e=e.multiply(d),e=e.add(Timestamp.fromNumber(h))}return e},Timestamp.INT_CACHE_={},Timestamp.TWO_PWR_16_DBL_=65536,Timestamp.TWO_PWR_24_DBL_=1<<24,Timestamp.TWO_PWR_32_DBL_=Timestamp.TWO_PWR_16_DBL_*Timestamp.TWO_PWR_16_DBL_,Timestamp.TWO_PWR_31_DBL_=Timestamp.TWO_PWR_32_DBL_/2,Timestamp.TWO_PWR_48_DBL_=Timestamp.TWO_PWR_32_DBL_*Timestamp.TWO_PWR_16_DBL_,Timestamp.TWO_PWR_64_DBL_=Timestamp.TWO_PWR_32_DBL_*Timestamp.TWO_PWR_32_DBL_,Timestamp.TWO_PWR_63_DBL_=Timestamp.TWO_PWR_64_DBL_/2,Timestamp.ZERO=Timestamp.fromInt(0),Timestamp.ONE=Timestamp.fromInt(1),Timestamp.NEG_ONE=Timestamp.fromInt(-1),Timestamp.MAX_VALUE=Timestamp.fromBits(-1,2147483647),Timestamp.MIN_VALUE=Timestamp.fromBits(0,-2147483648),Timestamp.TWO_PWR_24_=Timestamp.fromInt(1<<24),typeof window=="undefined"&&(exports.Timestamp=Timestamp);if(typeof window=="undefined")var Long=require("./long").Long,Double=require("./double").Double,Timestamp=require("./timestamp").Timestamp,ObjectID=require("./objectid").ObjectID,Symbol=require("./symbol").Symbol,Code=require("./code").Code,MinKey=require("./min_key").MinKey,MaxKey=require("./max_key").MaxKey,DBRef=require("./db_ref").DBRef,Binary=require("./binary").Binary,BinaryParser=require("./binary_parser").BinaryParser,writeIEEE754=require("./float_parser").writeIEEE754,readIEEE754=require("./float_parser").readIEEE754;BSON.BSON_INT32_MAX=2147483647,BSON.BSON_INT32_MIN=-2147483648,BSON.BSON_INT64_MAX=Math.pow(2,63)-1,BSON.BSON_INT64_MIN=-Math.pow(2,63),BSON.JS_INT_MAX=9007199254740992,BSON.JS_INT_MIN=-9007199254740992;var JS_INT_MAX_LONG=Long.fromNumber(9007199254740992),JS_INT_MIN_LONG=Long.fromNumber(-9007199254740992);BSON.BSON_DATA_NUMBER=1,BSON.BSON_DATA_STRING=2,BSON.BSON_DATA_OBJECT=3
,BSON.BSON_DATA_ARRAY=4,BSON.BSON_DATA_BINARY=5,BSON.BSON_DATA_OID=7,BSON.BSON_DATA_BOOLEAN=8,BSON.BSON_DATA_DATE=9,BSON.BSON_DATA_NULL=10,BSON.BSON_DATA_REGEXP=11,BSON.BSON_DATA_CODE=13,BSON.BSON_DATA_SYMBOL=14,BSON.BSON_DATA_CODE_W_SCOPE=15,BSON.BSON_DATA_INT=16,BSON.BSON_DATA_TIMESTAMP=17,BSON.BSON_DATA_LONG=18,BSON.BSON_DATA_MIN_KEY=255,BSON.BSON_DATA_MAX_KEY=127,BSON.BSON_BINARY_SUBTYPE_DEFAULT=0,BSON.BSON_BINARY_SUBTYPE_FUNCTION=1,BSON.BSON_BINARY_SUBTYPE_BYTE_ARRAY=2,BSON.BSON_BINARY_SUBTYPE_UUID=3,BSON.BSON_BINARY_SUBTYPE_MD5=4,BSON.BSON_BINARY_SUBTYPE_USER_DEFINED=128,BSON.calculateObjectSize=function(b,c){var d=5;if(Array.isArray(b))for(var e=0;e<b.length;e++)d+=calculateElement(e.toString(),b[e],c);else for(var f in b)d+=calculateElement(f,b[f],c);return d},BSON.serializeWithBufferAndIndex=function(b,c,d,e,f){f=f==null?!1:f;var g=d.length;return d[e++]=g&255,d[e++]=g>>8&255,d[e++]=g>>16&255,d[e++]=g>>24&255,serializeObject(b,c,d,e,f)-1};var serializeObject=function(a,b,c,d,e){if(Array.isArray(a))for(var f=0;f<a.length;f++)d=packElement(f.toString(),a[f],b,c,d,e);else for(var g in a)b==1&&g!="$db"&&g!="$ref"&&g!="$id"&&BSON.checkKey(g),d=packElement(g,a[g],b,c,d,e);return c[d++]=0,d},stringToBytes=function(a){var b,c,d=[];for(var e=0;e<a.length;e++){b=a.charCodeAt(e),c=[];do c.push(b&255),b>>=8;while(b);d=d.concat(c.reverse())}return d},numberOfBytes=function(a){var b,c,d=0;for(var e=0;e<a.length;e++){b=a.charCodeAt(e),c=[];do c.push(b&255),b>>=8;while(b);d+=c.length}return d},writeToTypedArray=function(a,b,c){var d=stringToBytes(b);for(var e=0;e<d.length;e++)a[c+e]=d[e];return d.length},supportsBuffer=typeof Buffer!="undefined",packElement=function(a,b,c,d,e,f){var g=e;switch(typeof b){case"string":d[e++]=BSON.BSON_DATA_STRING;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var i=supportsBuffer?Buffer.byteLength(b)+1:numberOfBytes(b)+1;return d[e+3]=i>>24&255,d[e+2]=i>>16&255,d[e+1]=i>>8&255,d[e]=i&255,e+=4,supportsBuffer?d.write(b,e,"utf8"):writeToTypedArray(d,b,e),e=e+i-1,d[e++]=0,e;case"number":if(Math.floor(b)===b&&b>=BSON.JS_INT_MIN&&b<=BSON.JS_INT_MAX)if(b>=BSON.BSON_INT32_MIN&&b<=BSON.BSON_INT32_MAX){d[e++]=BSON.BSON_DATA_INT;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0,d[e++]=b&255,d[e++]=b>>8&255,d[e++]=b>>16&255,d[e++]=b>>24&255}else if(b>=BSON.JS_INT_MIN&&b<=BSON.JS_INT_MAX){d[e++]=BSON.BSON_DATA_NUMBER;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0,writeIEEE754(d,b,e,"little",52,8),e+=8}else{d[e++]=BSON.BSON_DATA_LONG;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var j=Long.fromNumber(b),k=j.getLowBits(),l=j.getHighBits();d[e++]=k&255,d[e++]=k>>8&255,d[e++]=k>>16&255,d[e++]=k>>24&255,d[e++]=l&255,d[e++]=l>>8&255,d[e++]=l>>16&255,d[e++]=l>>24&255}else{d[e++]=BSON.BSON_DATA_NUMBER;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0,writeIEEE754(d,b,e,"little",52,8),e+=8}return e;case"undefined":d[e++]=BSON.BSON_DATA_NULL;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);return e=e+h+1,d[e-1]=0,e;case"boolean":d[e++]=BSON.BSON_DATA_BOOLEAN;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);return e=e+h+1,d[e-1]=0,d[e++]=b?1:0,e;case"object":if(b===null||b instanceof MinKey||b instanceof MaxKey||b["_bsontype"]=="MinKey"||b["_bsontype"]=="MaxKey"){b===null?d[e++]=BSON.BSON_DATA_NULL:b instanceof MinKey?d[e++]=BSON.BSON_DATA_MIN_KEY:d[e++]=BSON.BSON_DATA_MAX_KEY;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);return e=e+h+1,d[e-1]=0,e}if(b instanceof ObjectID||b["_bsontype"]=="ObjectID"){d[e++]=BSON.BSON_DATA_OID;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);return e=e+h+1,d[e-1]=0,supportsBuffer?d.write(b.id,e,"binary"):writeToTypedArray(d,b.id,e),e+=12,e}if(b instanceof Date){d[e++]=BSON.BSON_DATA_DATE;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var m=Long.fromNumber(b.getTime()),k=m.getLowBits(),l=m.getHighBits();return d[e++]=k&255,d[e++]=k>>8&255,d[e++]=k>>16&255,d[e++]=k>>24&255,d[e++]=l&255,d[e++]=l>>8&255,d[e++]=l>>16&255,d[e++]=l>>24&255,e}if(typeof Buffer!="undefined"&&Buffer.isBuffer(b)){d[e++]=BSON.BSON_DATA_BINARY;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var i=b.length;return d[e++]=i&255,d[e++]=i>>8&255,d[e++]=i>>16&255,d[e++]=i>>24&255,d[e++]=BSON.BSON_BINARY_SUBTYPE_DEFAULT,b.copy(d,e,0,i),e+=i,e}if(b instanceof Long||b instanceof Timestamp||b["_bsontype"]=="Long"||b["_bsontype"]=="Timestamp"){d[e++]=b instanceof Long?BSON.BSON_DATA_LONG:BSON.BSON_DATA_TIMESTAMP;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var k=b.getLowBits(),l=b.getHighBits();return d[e++]=k&255,d[e++]=k>>8&255,d[e++]=k>>16&255,d[e++]=k>>24&255,d[e++]=l&255,d[e++]=l>>8&255,d[e++]=l>>16&255,d[e++]=l>>24&255,e}if(b instanceof Double||b["_bsontype"]=="Double"){d[e++]=BSON.BSON_DATA_NUMBER;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);return e=e+h+1,d[e-1]=0,writeIEEE754(d,b,e,"little",52,8),e+=8,e}if(b instanceof Code||b["_bsontype"]=="Code"){if(b.scope!=null&&Object.keys(b.scope).length>0){d[e++]=BSON.BSON_DATA_CODE_W_SCOPE;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var n=BSON.calculateObjectSize(b.scope,f),o=b.code.toString(),p=supportsBuffer?Buffer.byteLength(o)+1:numberOfBytes(o)+1,q=4+p+n+4;d[e++]=q&255,d[e++]=q>>8&255,d[e++]=q>>16&255,d[e++]=q>>24&255,d[e++]=p&255,d[e++]=p>>8&255,d[e++]=p>>16&255,d[e++]=p>>24&255,supportsBuffer?d.write(o,e,"utf8"):writeToTypedArray(d,o,e),e=e+p-1,d[e++]=0;var r=supportsBuffer?new Buffer(n):new Uint8Array(new ArrayBuffer(n));serializeObject(b.scope,c,r,0,f);var s=n;return d[e++]=s&255,d[e++]=s>>8&255,d[e++]=s>>16&255,d[e++]=s>>24&255,supportsBuffer?r.copy(d,e,0,n):d.set(r,e),e=e+s-5,d[e++]=0,e}d[e++]=BSON.BSON_DATA_CODE;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var o=b.code.toString(),i=supportsBuffer?Buffer.byteLength(o)+1:numberOfBytes(o)+1;return d[e++]=i&255,d[e++]=i>>8&255,d[e++]=i>>16&255,d[e++]=i>>24&255,d.write(o,e,"utf8"),e=e+i-1,d[e++]=0,e}if(b instanceof Binary||b["_bsontype"]=="Binary"){d[e++]=BSON.BSON_DATA_BINARY;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var t=b.value(!0),i=b.position;return d[e++]=i&255,d[e++]=i>>8&255,d[e++]=i>>16&255,d[e++]=i>>24&255,d[e++]=b.sub_type,supportsBuffer?t.copy(d,e,0,b.position):d.set(t,e),e+=b.position,e}if(b instanceof Symbol||b["_bsontype"]=="Symbol"){d[e++]=BSON.BSON_DATA_SYMBOL;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var i=supportsBuffer?Buffer.byteLength(b.value)+1:numberOfBytes(b.value)+1;return d[e++]=i&255,d[e++]=i>>8&255,d[e++]=i>>16&255,d[e++]=i>>24&255,d.write(b.value,e,"utf8"),e=e+i-1,d[e++]=0,e}if(b instanceof DBRef||b["_bsontype"]=="DBRef"){d[e++]=BSON.BSON_DATA_OBJECT;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var u={$ref:b.namespace,$id:b.oid};null!=b.db&&(u.$db=b.db);var i=BSON.calculateObjectSize(u,f),v=BSON.serializeWithBufferAndIndex(u,c,d,e,f);return d[e++]=i&255,d[e++]=i>>8&255,d[e++]=i>>16&255,d[e++]=i>>24&255,d[v++]=0,v}if(b instanceof RegExp||Object.prototype.toString.call(b)==="[object RegExp]"){d[e++]=BSON.BSON_DATA_REGEXP;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);return e=e+h+1,d[e-1]=0,supportsBuffer?d.write(b.source,e,"utf8"):writeToTypedArray(d,b.source,e),e+=supportsBuffer?Buffer.byteLength(b.source):numberOfBytes(b.source),d[e++]=0,b.global&&(d[e++]=115),b.ignoreCase&&(d[e++]=105),b.multiline&&(d[e++]=109),d[e++]=0,e}d[e++]=Array.isArray(b)?BSON.BSON_DATA_ARRAY:BSON.BSON_DATA_OBJECT;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var v=serializeObject(b,c,d,e+4,f),i=v-e;return d[e++]=i&255,d[e++]=i>>8&255,d[e++]=i>>16&255,d[e++]=i>>24&255,v;case"function":if(b instanceof RegExp||Object.prototype.toString.call(b)==="[object RegExp]"||String.call(b)=="[object RegExp]"){d[e++]=BSON.BSON_DATA_REGEXP;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);return e=e+h+1,d[e-1]=0,d.write(b.source,e,"utf8"),e+=supportsBuffer?Buffer.byteLength(b.source):numberOfBytes(b.source),d[e++]=0,b.global&&(d[e++]=115),b.ignoreCase&&(d[e++]=105),b.multiline&&(d[e++]=109),d[e++]=0,e}if(f&&b.scope!=null&&Object.keys(b.scope).length>0){d[e++]=BSON.BSON_DATA_CODE_W_SCOPE;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var n=BSON.calculateObjectSize(b.scope,f),o=b.toString(),p=supportsBuffer?Buffer.byteLength(o)+1:numberOfBytes(o)+1,q=4+p+n;d[e++]=q&255,d[e++]=q>>8&255,d[e++]=q>>16&255,d[e++]=q>>24&255,d[e++]=p&255,d[e++]=p>>8&255,d[e++]=p>>16&255,d[e++]=p>>24&255,d.write(o,e,"utf8"),e=e+p-1,d[e++]=0;var r=new Buffer(n);serializeObject(b.scope,c,r,0,f);var s=n-4;return d[e++]=s&255,d[e++]=s>>8&255,d[e++]=s>>16&255,d[e++]=s>>24&255,r.copy(d,e,0,n),e=e+s-5,d[e++]=0,e}if(f){d[e++]=BSON.BSON_DATA_CODE;var h=supportsBuffer?d.write(a,e,"utf8"):writeToTypedArray(d,a,e);e=e+h+1,d[e-1]=0;var o=b.toString(),i=supportsBuffer?Buffer.byteLength(o)+1:numberOfBytes(o)+1;return d[e++]=i&255,d[e++]=i>>8&255,d[e++]=i>>16&255,d[e++]=i>>24&255,d.write(o,e,"utf8"),e=e+i-1,d[e++]=0,e}}return e};BSON.serialize=function(a,b,c,d){var e=null,f=BSON.calculateObjectSize(a,d);return(e=typeof Buffer!="undefined")?(e=new Buffer(f),c=!0):typeof Uint8Array!="undefined"?e=new Uint8Array(new ArrayBuffer(f)):e=new Array(f),BSON.serializeWithBufferAndIndex(a,b,e,0,d),e};var functionCache=BSON.functionCache={},table=[0,1996959894,3993919788,2567524794,124634137,1886057615,3915621685,2657392035,249268274,2044508324,3772115230,2547177864,162941995,2125561021,3887607047,2428444049,498536548,1789927666,4089016648,2227061214,450548861,1843258603,4107580753,2211677639,325883990,1684777152,4251122042,2321926636,335633487,1661365465,4195302755,2366115317,997073096,1281953886,3579855332,2724688242,1006888145,1258607687,3524101629,2768942443,901097722,1119000684,3686517206,2898065728,853044451,1172266101,3705015759,2882616665,651767980,1373503546,3369554304,3218104598,565507253,1454621731,3485111705,3099436303,671266974,1594198024,3322730930,2970347812,795835527,1483230225,3244367275,3060149565,1994146192,31158534,2563907772,4023717930,1907459465,112637215,2680153253,3904427059,2013776290,251722036,2517215374,3775830040,2137656763,141376813,2439277719,3865271297,1802195444,476864866,2238001368,4066508878,1812370925,453092731,2181625025,4111451223,1706088902,314042704,2344532202,4240017532,1658658271,366619977,2362670323,4224994405,1303535960,984961486,2747007092,3569037538,1256170817,1037604311,2765210733,3554079995,1131014506,879679996,2909243462,3663771856,1141124467,855842277,2852801631,3708648649,1342533948,654459306,3188396048,3373015174,1466479909,544179635,3110523913,3462522015,1591671054,702138776,2966460450,3352799412,1504918807,783551873,3082640443,3233442989,3988292384,2596254646,62317068,1957810842,3939845945,2647816111,81470997,1943803523,3814918930,2489596804,225274430,2053790376,3826175755,2466906013,167816743,2097651377,4027552580,2265490386,503444072,1762050814,4150417245,2154129355,426522225,1852507879,4275313526,2312317920,282753626,1742555852,4189708143,2394877945,397917763,1622183637,3604390888,2714866558,953729732,1340076626,3518719985,2797360999,1068828381,1219638859,3624741850,2936675148,906185462,1090812512,3747672003,2825379669,829329135,1181335161,3412177804,3160834842,628085408,1382605366,3423369109,3138078467,570562233,1426400815,3317316542,2998733608,733239954,1555261956,3268935591,3050360625,752459403,1541320221,2607071920,3965973030,1969922972,40735498,2617837225,3943577151,1913087877,83908371,2512341634,3803740692,2075208622,213261112,2463272603,3855990285,2094854071,198958881,2262029012,4057260610,1759359992,534414190,2176718541,4139329115,1873836001,414664567,2282248934,4279200368,1711684554,285281116,2405801727,4167216745,1634467795,376229701,2685067896,3608007406,1308918612,956543938,2808555105,3495958263,1231636301,1047427035,2932959818,3654703836,1088359270,936918e3,2847714899,3736837829,1202900863,817233897,3183342108,3401237130,1404277552,615818150,3134207493,3453421203,1423857449,601450431,3009837614,3294710456,1567103746,711928724,3020668471,3272380065,1510334235,755167117],crc32=function(a,b,c){var d=0,e=0,f=0;d^=-1;for(var g=b,h=c;g<h;g++)f=(d^a[g])&255,e=table[f],d=d>>>8^e;return d^-1};BSON.deserializeStream=function(a,b,c,d,e,f){f=f!=null?f:{};var g=b;for(var h=0;h<c;h++){var i=a[g]|a[g+1]<<8|a[g+2]<<16|a[g+3]<<24;f.index=g,d[e+h]=BSON.deserialize(a,f),g+=i}return g};var isolateEvalWithHash=function(functionCache,hash,functionString,object){var value=null;return functionCache[hash]==null&&(eval("value = "+functionString),functionCache[hash]=value),functionCache[hash].bind(object)},isolateEval=function(functionString){var value=null;return eval("value = "+functionString),value},convertUint8ArrayToUtf8String=function(a,b,c){return BinaryParser.decode_utf8(convertArraytoUtf8BinaryString(a,b,c))},convertArraytoUtf8BinaryString=function(a,b,c){var d="";for(var e=b;e<c;e++)d+=String.fromCharCode(a[e]);return d};BSON.deserialize=function(a,b,c){b=b==null?{}:b;var d=b["evalFunctions"]==null?!1:b.evalFunctions,e=b["cacheFunctions"]==null?!1:b.cacheFunctions,f=b["cacheFunctionsCrc32"]==null?!1:b.cacheFunctionsCrc32;if(a.length<5)throw new Error("corrupt bson message < 5 bytes long");var g=typeof b["index"]=="number"?b.index:0,h=function(){var b=g;while(a[b]!==0)b++;var c=supportsBuffer&&Buffer.isBuffer(a)?a.toString("utf8",g,b):convertUint8ArrayToUtf8String(a,g,b);return g=b+1,c},i=c?[]:{},j=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24;if(j<5||j>a.length)throw new Error("corrupt bson message");for(;;){var k=a[g++];if(k==0)break;var l=h();switch(k){case BSON.BSON_DATA_OID:var m=supportsBuffer&&Buffer.isBuffer(a)?a.toString("binary",g,g+12):convertArraytoUtf8BinaryString(a,g,g+12);i[l]=new ObjectID(m),g+=12;break;case BSON.BSON_DATA_STRING:var n=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24;i[l]=supportsBuffer&&Buffer.isBuffer(a)?a.toString("utf8",g,g+n-1):convertUint8ArrayToUtf8String(a,g,g+n-1),g+=n;break;case BSON.BSON_DATA_INT:i[l]=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24;break;case BSON.BSON_DATA_NUMBER:i[l]=readIEEE754(a,g,"little",52,8),g+=8;break;case BSON.BSON_DATA_DATE:var o=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24,p=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24;i[l]=new Date((new Long(o,p)).toNumber());break;case BSON.BSON_DATA_BOOLEAN:i[l]=a[g++]==1;break;case BSON.BSON_DATA_NULL:i[l]=null;break;case BSON.BSON_DATA_BINARY:var q=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24,r=a[g++];if(a["slice"]!=null)i[l]=new Binary(a.slice(g,g+q),r);else{var s=typeof Uint8Array!="undefined"?new Uint8Array(new ArrayBuffer(q)):new Array(q);for(var t=0;t<q;t++)s[t]=a[g+t];i[l]=new Binary(s,r)}g+=q;break;case BSON.BSON_DATA_ARRAY:b.index=g;var u=a[g]|a[g+1]<<8|a[g+2]<<16|a[g+3]<<24;i[l]=BSON.deserialize(a,b,!0),g+=u;break;case BSON.BSON_DATA_OBJECT:b.index=g;var u=a[g]|a[g+1]<<8|a[g+2]<<16|a[g+3]<<24;i[l]=BSON.deserialize(a,b,!1),g+=u;break;case BSON.BSON_DATA_REGEXP:var v=h(),w=h(),x=new Array(w.length);for(var t=0;t<w.length;t++)switch(w[t]){case"m":x[t]="m";break;case"s":x[t]="g";break;case"i":x[t]="i"}i[l]=new RegExp(v,x.join(""));break;case BSON.BSON_DATA_LONG:var o=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24,p=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24,y=new Long(o,p);i[l]=y.lessThanOrEqual(JS_INT_MAX_LONG)&&y.greaterThanOrEqual(JS_INT_MIN_LONG)?y.toNumber():y;break;case BSON.BSON_DATA_SYMBOL:var n=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24;i[l]=new Symbol(a.toString("utf8",g,g+n-1)),g+=n;break;case BSON.BSON_DATA_TIMESTAMP:var o=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24,p=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24;i[l]=new Timestamp(o,p);break;case BSON.BSON_DATA_MIN_KEY:i[l]=new MinKey;break;case BSON.BSON_DATA_MAX_KEY:i[l]=new MaxKey;break;case BSON.BSON_DATA_CODE:var n=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24,z=supportsBuffer&&Buffer.isBuffer(a)?a.toString("utf8",g,g+n-1):convertUint8ArrayToUtf8String(a,g,g+n-1);if(d){var A=null;if(e){var B=f?crc32(z):z;i[l]=isolateEvalWithHash(functionCache,B,z,i)}else i[l]=isolateEval(z)}else i[l]=new Code(z,{});g+=n;break;case BSON.BSON_DATA_CODE_W_SCOPE:var C=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24,n=a[g++]|a[g++]<<8|a[g++]<<16|a[g++]<<24,z=supportsBuffer&&Buffer.isBuffer(a)?a.toString("utf8",g,g+n-1):convertUint8ArrayToUtf8String(a,g,g+n-1);g+=n,b.index=g;var u=a[g]|a[g+1]<<8|a[g+2]<<16|a[g+3]<<24,D=BSON.deserialize(a,b,!1);g+=u;if(d){var A=null;if(e){var B=f?crc32(z):z;i[l]=isolateEvalWithHash(functionCache,B,z,i)}else i[l]=isolateEval(z);i[l].scope=D}else i[l]=new Code(z,D)}}return i["$id"]!=null&&(i=new DBRef(i.$ref,i.$id,i.$db)),i},BSON.checkKey=function(b){if(!b.length)return;if("$"==b[0])throw Error("key "+b+" must not start with '$'");if(!!~b.indexOf("."))throw Error("key "+b+" must not contain '.'")},BSON.prototype.deserialize=function(a,b){return BSON.deserialize(a,b)},BSON.prototype.deserializeStream=function(a,b,c,d,e,f){return BSON.deserializeStream(a,b,c,d,e,f)},BSON.prototype.serialize=function(a,b,c,d){return BSON.serialize(a,b,c,d)},BSON.prototype.calculateObjectSize=function(a,b){return BSON.calculateObjectSize(a,b)},BSON.prototype.serializeWithBufferAndIndex=function(a,b,c,d,e){return BSON.serializeWithBufferAndIndex(a,b,c,d,e)},typeof window=="undefined"&&(exports.Code=Code,exports.Symbol=Symbol,exports.BSON=BSON,exports.DBRef=DBRef,exports.Binary=Binary,exports.ObjectID=ObjectID,exports.Long=Long,exports.Timestamp=Timestamp,exports.Double=Double,exports.MinKey=MinKey,exports.MaxKey=MaxKey);if(typeof window=="undefined")var Buffer=require("buffer").Buffer,bson=require("./bson");var BSON_BINARY_SUBTYPE_DEFAULT=0,writeStringToArray=function(a){var b=typeof Uint8Array!="undefined"?new Uint8Array(new ArrayBuffer(a.length)):new Array(a.length);for(var c=0;c<a.length;c++)b[c]=a.charCodeAt(c);return b},convertArraytoUtf8BinaryString=function(a,b,c){var d="";for(var e=b;e<c;e++)d+=String.fromCharCode(a[e]);return d};Binary.prototype.put=function(b){if(b["length"]!=null&&typeof b!="number"&&b.length!=1)throw new Error("only accepts single character String, Uint8Array or Array");if(typeof b!="number"&&b<0||b>255)throw new Error("only accepts number in a valid unsigned byte range 0-255");var c=null;typeof b=="string"?c=b.charCodeAt(0):b["length"]!=null?c=b[0]:c=b;if(this.buffer.length>this.position)this.buffer[this.position++]=c;else if(typeof Buffer!="undefined"&&Buffer.isBuffer(this.buffer)){var d=new Buffer(Binary.BUFFER_SIZE+this.buffer.length);this.buffer.copy(d,0,0,this.buffer.length),this.buffer=d,this.buffer[this.position++]=c}else{var d=null;Object.prototype.toString.call(this.buffer)=="[object Uint8Array]"?d=new Uint8Array(new ArrayBuffer(Binary.BUFFER_SIZE+this.buffer.length)):d=new Array(Binary.BUFFER_SIZE+this.buffer.length);for(var e=0;e<this.buffer.length;e++)d[e]=this.buffer[e];this.buffer=d,this.buffer[this.position++]=c}},Binary.prototype.write=function(b,c){c=typeof c=="number"?c:this.position;if(this.buffer.length<c+b.length){var d=null;if(typeof Buffer!="undefined"&&Buffer.isBuffer(this.buffer))d=new Buffer(this.buffer.length+b.length),this.buffer.copy(d,0,0,this.buffer.length);else if(Object.prototype.toString.call(this.buffer)=="[object Uint8Array]"){d=new Uint8Array(new ArrayBuffer(this.buffer.length+b.length));for(var e=0;e<this.position;e++)d[e]=this.buffer[e]}this.buffer=d}if(typeof Buffer!="undefined"&&Buffer.isBuffer(b)&&Buffer.isBuffer(this.buffer))b.copy(this.buffer,c,0,b.length),this.position=c+b.length>this.position?c+b.length:this.position;else if(typeof Buffer!="undefined"&&typeof b=="string"&&Buffer.isBuffer(this.buffer))this.buffer.write(b,"binary",c),this.position=c+b.length>this.position?c+b.length:this.position;else if(Object.prototype.toString.call(b)=="[object Uint8Array]"||Object.prototype.toString.call(b)=="[object Array]"&&typeof b!="string"){for(var e=0;e<b.length;e++)this.buffer[c++]=b[e];this.position=c>this.position?c:this.position}else if(typeof b=="string"){for(var e=0;e<b.length;e++)this.buffer[c++]=b.charCodeAt(e);this.position=c>this.position?c:this.position}},Binary.prototype.read=function(b,c){c=c&&c>0?c:this.position;if(this.buffer.slice)return this.buffer.slice(b,b+c);var d=typeof Uint8Array!="undefined"?new Uint8Array(new ArrayBuffer(c)):new Array(c);for(var e=0;e<c;e++)d[e]=this.buffer[b++];return d},Binary.prototype.value=function(b){b=b==null?!1:b;if(typeof Buffer!="undefined"&&Buffer.isBuffer(this.buffer))return b?this.buffer.slice(0,this.position):this.buffer.toString("binary",0,this.position);if(b){if(this.buffer["slice"]!=null)return this.buffer.slice(0,this.position);var c=Object.prototype.toString.call(this.buffer)=="[object Uint8Array]"?new Uint8Array(new ArrayBuffer(this.position)):new Array(this.position);for(var d=0;d<this.position;d++)c[d]=this.buffer[d];return c}return convertArraytoUtf8BinaryString(this.buffer,0,this.position)},Binary.prototype.length=function(){return this.position},Binary.prototype.toJSON=function(){return this.buffer!=null?this.buffer.toString("base64"):""},Binary.prototype.toString=function(a){return this.buffer!=null?this.buffer.slice(0,this.position).toString(a):""},Binary.BUFFER_SIZE=256,Binary.SUBTYPE_DEFAULT=0,Binary.SUBTYPE_FUNCTION=1,Binary.SUBTYPE_BYTE_ARRAY=2,Binary.SUBTYPE_UUID=3,Binary.SUBTYPE_MD5=4,Binary.SUBTYPE_USER_DEFINED=128,typeof window=="undefined"&&(exports.Binary=Binary);